import { ArrayChunk } from '../../types/rga-array/ArrayChunk';
import { ArrayType } from '../../types/rga-array/ArrayType';
import { BinaryChunk } from '../../types/rga-binary/BinaryChunk';
import { BinaryType } from '../../types/rga-binary/BinaryType';
import { ConstantType } from '../../types/const/ConstantType';
import { ITimestamp } from '../../../json-crdt-patch/clock';
import { JsonNode } from '../../types';
import { Model } from '../../model';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { StringChunk } from '../../types/rga-string/StringChunk';
import { StringType } from '../../types/rga-string/StringType';
import { ValueType } from '../../types/lww-value/ValueType';
import { RootJsonCrdtNode, JsonCrdtNode, ObjectJsonCrdtNode, ArrayJsonCrdtNode, ArrayJsonCrdtChunk, JsonCrdtRgaTombstone, ValueJsonCrdtNode, StringJsonCrdtNode, StringJsonCrdtChunk, ConstantJsonCrdtNode, BinaryJsonCrdtNode, BinaryJsonCrdtChunk } from './types';
export declare abstract class AbstractDecoder<Id> {
    protected abstract decodeTimestamp(id: Id): ITimestamp;
    protected decodeRoot(doc: Model, { id, node }: RootJsonCrdtNode<Id>): void;
    protected decodeNode(doc: Model, node: JsonCrdtNode<Id>): JsonNode;
    protected decodeObj(doc: Model, node: ObjectJsonCrdtNode<Id>): ObjectType;
    protected decodeArr(doc: Model, node: ArrayJsonCrdtNode<Id>): ArrayType;
    protected decodeArrChunk(doc: Model, c: ArrayJsonCrdtChunk<Id> | JsonCrdtRgaTombstone<Id>): ArrayChunk;
    protected decodeStr(doc: Model, node: StringJsonCrdtNode<Id>): StringType;
    protected decodeStrChunk(doc: Model, c: StringJsonCrdtChunk<Id> | JsonCrdtRgaTombstone<Id>): StringChunk;
    protected decodeBin(doc: Model, node: BinaryJsonCrdtNode<Id>): BinaryType;
    protected decodeBinChunk(doc: Model, c: BinaryJsonCrdtChunk<Id> | JsonCrdtRgaTombstone<Id>): BinaryChunk;
    protected decodeVal(doc: Model, node: ValueJsonCrdtNode<Id>): ValueType;
    protected decodeConst(doc: Model, node: ConstantJsonCrdtNode): ConstantType;
}
