import { ArrayChunk } from '../../types/rga-array/ArrayChunk';
import { ArrayType } from '../../types/rga-array/ArrayType';
import { BinaryChunk } from '../../types/rga-binary/BinaryChunk';
import { BinaryType } from '../../types/rga-binary/BinaryType';
import { ConstantType } from '../../types/const/ConstantType';
import { DocRootType } from '../../types/lww-doc-root/DocRootType';
import { EncoderFull as JsonPackEncoder } from '../../../json-pack/EncoderFull';
import { ITimestamp } from '../../../json-crdt-patch/clock';
import { JsonNode } from '../../types';
import { ObjectChunk } from '../../types/lww-object/ObjectChunk';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { StringChunk } from '../../types/rga-string/StringChunk';
import { StringType } from '../../types/rga-string/StringType';
import { ValueType } from '../../types/lww-value/ValueType';
export declare abstract class AbstractEncoder extends JsonPackEncoder {
    protected abstract ts(ts: ITimestamp): void;
    protected encodeRoot(root: DocRootType): void;
    protected encodeNode(node: JsonNode): void;
    protected encodeObj(obj: ObjectType): void;
    protected encodeObjChunk(key: string, chunk: ObjectChunk): void;
    protected encodeArr(obj: ArrayType): void;
    protected encodeArrChunk(chunk: ArrayChunk): void;
    protected encodeStr(obj: StringType): void;
    protected encodeStrChunk(chunk: StringChunk): void;
    protected encodeBin(obj: BinaryType): void;
    protected encodeBinChunk(chunk: BinaryChunk): void;
    protected encodeConst(obj: ConstantType): void;
    protected encodeVal(obj: ValueType): void;
    private encodeUtf8;
    id(x: number, y: number): void;
    vuint57(num: number): void;
    vuint39(num: number): void;
    b1vuint56(flag: boolean, num: number): void;
    b1vuint28(flag: boolean, num: number): void;
    uint53vuint39(x: number, z: number): void;
}
